// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers', 'starter.services', 'ngAnimate', 'ngCordova', 'morphCarousel'])

.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }

   var admobid = {};
    if( /(android)/i.test(navigator.userAgent) ) { // for android & amazon-fireos
        admobid = {
            banner: 'ca-app-pub-2095701797403295/2891470165', // or DFP format "/6253334/dfp_example_ad"
            interstitial: 'ca-app-pub-2095701797403295/8070046160'
        };
    } else if(/(ipod|iphone|ipad)/i.test(navigator.userAgent)) { // for ios
        admobid = {
            banner: 'ca-app-pub-2095701797403295/2891470165', // or DFP format "/6253334/dfp_example_ad"
            interstitial: 'ca-app-pub-2095701797403295/8070046160'
        };
    } else { // for windows phone
        admobid = {
            banner: 'ca-app-pub-2095701797403295/2891470165', // or DFP format "/6253334/dfp_example_ad"
            interstitial: 'ca-app-pub-2095701797403295/8070046160'
        };
    }

      
          if(AdMob) { AdMob.createBanner( {
    adId: admobid.banner, 
    isTesting: false,
    position: AdMob.AD_POSITION.BOTTOM_CENTER, 
    autoShow: true } );
    }

      if(AdMob) AdMob.prepareInterstitial( {isTesting: false, adId:admobid.interstitial, autoShow:false} );




    
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
  });
})

.config(function($stateProvider, $urlRouterProvider) {

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider

  // setup an abstract state for the tabs directive
  .state('intro', {
    url:"/intro",
    abstract:false,
    templateUrl: "templates/intro.html"
  })
    .state('home', {
    url: '/home',
    abstract: false,
    templateUrl: 'templates/home.html'
  })

    .state('menu', {
    url: '/menu',
    abstract: false,
    templateUrl: 'templates/menu.html'
  })

    .state('lobby', {
    url: '/lobby',
    abstract: false,
    templateUrl: 'templates/lobby.html'
  })

    .state('create', {
      url: "/create",
      abstract:false,
      templateUrl: "templates/create.html"
    })

  // Each tab has its own nav history stack:

  if(localStorage.getItem('username') == null) {
      $urlRouterProvider.otherwise('/intro');
  } else {
    $urlRouterProvider.otherwise('/menu');
  }

  
  // if none of the above states are matched, use this as the fallback

})

